/* 
 * Copyright (c) 2001, 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: alloc.c,v 1.5 2002/08/12 12:42:18 malekith Exp $
 *
 * Runtime environment for gont.
 *
 * Assumes compiler that allows $ in identifiers, such as GCC.
 * (It is required to have Ksi, so this ain't so important)
 */

#include <gont/runtime.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef GONT_USE_GC
#  include <gc/gc.h>
#else
#  define GC_malloc malloc
#  define GC_malloc_atomic malloc
#endif

static void oops(int s) __attribute__ ((__noreturn__));

static void oops(int s)
{
	gont_oops("Run out of memory, trying to allocate %d bytes.\n", s);
}

void *gont_xmalloc(gont_ptroff s)
{
	void *p = GC_malloc(s);

	if (p == NULL) 
		oops(s);
	else
		return p;
}

void *gont_xmalloc0(gont_ptroff s)
{
	void *p = GC_malloc(s);

	if (p) {
		memset(p, '\0', s);
		return p;
	} else {
		oops(s);
	}
}


void *gont_xmalloc_atomic(gont_ptroff s)
{
	void *p = GC_malloc_atomic(s);

	if (p == NULL) 
		oops(s);
	else
		return p;
}

void *gont_xmalloc0_atomic(gont_ptroff s)
{
	void *p = GC_malloc_atomic(s);

	if (p) {
		memset(p, '\0', s);
		return p;
	} else
		oops(s);
}
