/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: stack.g,v 1.1 2002/08/12 12:42:21 malekith Exp $
 *
 * Standard library for Gont, Stack module implementation.
 *
 * Mutable stack.
 */

struct <'a>t {
	<'a>List::t lst;
}

'a pop(<'a>t s)
{
	switch s.lst {
	case List::Nil:
		raise Invalid_argument["Stack::pop"];
	case List::Cons[hd, tl]:
		s.lst = tl;
		return hd;
	}
}

'a top(<'a>t s)
{
	switch s.lst {
	case List::Nil:
		raise Invalid_argument["Stack::top"];
	case List::Cons[hd, _]:
		return hd;
	}
}

bool empty(<'a>t s)
{
	switch s.lst {
	case List::Nil:
		return true;
	case List::Cons[_, _]:
		return false;
	}
}

void push(<'a>t s, 'a x)
{
	s.lst = List::Cons[x, s.lst];
}

<'a>t create()
{
	return ({lst = List::Nil});
}
